package chat.client;

import static chat.Globals.*;
import static chat.Cmds.*;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.Random;

import inout.In;
import inout.Out;

public class ChatClient {
	
	private Socket socket = null; 
	private BufferedReader reader; 
	private PrintWriter writer; 

	public static void main(String[] args) {
		ChatClient client = new ChatClient(); 
		client.start(); 
	}

	private void start() {
		Out.print("Enter your name: ");
		String name = "HANS" + new Random().nextInt(100); // In.readLine();
		try {
			socket = new Socket(HOST, PORT); 
			this.reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			this.writer = new PrintWriter(new OutputStreamWriter(socket.getOutputStream()));
			// <--- HELO ipaddr
			String helo = readLine(reader); 
			// ---> LOGIN name
			writeLine(writer, String.format("%s:%s", LOGIN, name));
			// <--- WHAT name
			String what = readLine(reader); 
			Out.print("Your request (terminate with ENTER): "); 
			String req = In.readLine().trim();
			while (req.length() > 0) {
				// ---> REQST req
				writeLine(writer, String.format("%s:%s", REQST, req));
				// <--- REPLY rep 
				String reply = readLine(reader); 
				Out.println("Reply from server is: " + reply.split(":")[1]);
				Out.print("Your request (terminate with ENTER): "); 
				req = In.readLine().trim();
			}
			// ---> END name 
			writeLine(writer, String.format("%s:%s", END, name));
			// <--- END name 
			String end = readLine(reader); 
			// ---> LOGOUT name 
			writeLine(writer, String.format("%s:%s", LOGOUT, name));
			// <--- BYE name 
			String bye = readLine(reader); 
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				socket.close();
			} catch (IOException e) { }
		}
	}
	
	

}
